"""file: euclid.py

Computes gcd, and Bezout coefficients

"""


"""gcd(a,b) returns the gcd of 'a' and 'b'

The method is Euclid's algorithm.

"""
def gcd(a,b):
  return a if b == 0 else gcd(b,a%b)


"""bezout(a,b) returns a triplet (d,u,v) where d is gcd(a,b) and au +
bv = d.

The method is Euclid's extended algorithm.

"""
def bezout(a,b):
  if b == 0 : return (a,1,0)
  else :
    """if ub + vr = d with a = qb + r euclidean division, then va+(u-vq)b
    = d

    """
    (d,u,v) = bezout(b,a%b)
    return (d,v,u-v*(a/b))

a,b = 73298,1990723
(d,u,v) =  bezout(a,b)
print "gcd of", a, "and", b, "is", d
print "In fact,", a, "*", u, "+", b, "*", v, "=", a*u+b*v
