# file: hanoi.py
# date: last updated on 30/09/2016
#
# description: correction of TP2's homework

# Hanoi game solver
#
# hanoi(start,stop,inter,n) gives a list of moves (i,j) (meaning i->j)
# to solve Hanoi game for n disk from the tower start to the tower
# stop.
def hanoi(start,stop,inter,n):
    # when there is no disk, it is kind of easy
    if n == 0: return []

    # otherwise, one reduct the problem with n disk to smaller
    # problems
    #
    # first, one need to move the n-1 smallest disk onto the
    # intermediary tower, using the stop tower as intermediary
    onto_inter = hanoi(start,inter,stop,n-1)
    # then the move for the big disk is start->stop
    move_big = (start,stop)
    # then, move the n-1 disks of the intermediary tower to the stop
    # tower using the start tower as intermediary
    from_inter = hanoi(inter,stop,start,n-1)
    # it remains to concatenate all those move
    return onto_inter + [move_big]+ from_inter

# Pretty print for the list of moves
#
# pp_moves(l) prints the moves contained in l
def pp_moves(l):
    for (i,j) in l: print str(i)+"->"+str(j),
    print
    return None


## main program

pp_moves(hanoi(1,3,2,10))

# Remark that the number of moves is exponential in the number of
# disk: if we call f(n) the number of moves for the game with n disks,
# then our algorithm makes f(n) = 2f(n-1)+1, meaning that
#
# f(n)+1 = 2(f(n-1)+1) = 2*2*(f(n-2)+1) = ... = 2^n (f(0)+1) = 2^n
#
# Hence, f(n) = 2^n - 1. (Which explains that even for n=20, the
# program needs several seconds.)
